



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux文件锁flock</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux文件锁flock</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 18:27:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Linux文件锁flock</p>
<p>在多个进程同时操作同一份文件的过程中，很容易导致文件中的数据混乱，需要锁操作来保证数据的完整性，这里介绍的针对文件的锁，称之为&ldquo;文件锁&rdquo;-flock。</p>
<p>flock，建议性锁，不具备强制性。一个进程使用flock将文件锁住，另一个进程可以直接操作正在被锁的文件，修改文件中的数据，原因在于flock只是用于检测文件是否被加锁，针对文件已经被加锁，另一个进程写入数据的情况，内核不会阻止这个进程的写入操作，也就是建议性锁的内核处理策略。</p>
<p>flock主要三种操作类型：<br />     LOCK_SH，共享锁，多个进程可以使用同一把锁，常被用作读共享锁；<br />     LOCK_EX，排他锁，同时只允许一个进程使用，常被用作写锁；<br />     LOCK_UN，释放锁；</p>
<p>进程使用flock尝试锁文件时，如果文件已经被其他进程锁住，进程会被阻塞直到锁被释放掉，或者在调用flock的时候，采用LOCK_NB参数，在尝试锁住该文件的时候，发现已经被其他服务锁住，会返回错误，errno错误码为EWOULDBLOCK。即提供两种工作模式：阻塞与非阻塞类型。</p>
<p>服务会阻塞等待直到锁被释放：<br />flock(lockfd,LOCK_EX)<br />服务会返回错误发现文件已经被锁住时：<br />ret  = flock(lockfd,LOCK_EX|LOCK_NB)<br />同时ret = -1, errno = EWOULDBLOCK</p>
<p>flock锁的释放非常具有特色，即可调用LOCK_UN参数来释放文件锁，也可以通过关闭fd的方式来释放文件锁（flock的第一个参数是fd），意味着flock会随着进程的关闭而被自动释放掉。</p>
<p>flock其中的一个使用场景为：检测进程是否已经存在；</p>
<div>
<pre class="prettyprint linenums">int checkexit(char* pfile)<br />
{<br />
    if (pfile == NULL)<br />
    {<br />
        return -;<br />
    }<br />
    int lockfd = open(pfile,O_RDWR);<br />
    if (lockfd == -)<br />
    {<br />
        return -;<br />
    }<br />
    int iret = flock(lockfd,LOCK_EX|LOCK_NB);<br />
    if (iret == -)<br />
    {<br />
        return -;<br />
    }   

    return ;<br />
}</pre>
</div>
<p>来源：<a href="http://blog.csdn.net/jiang1013nan/article/details/17849499" rel="external nofollow noreferrer">http://blog.csdn.net/jiang1013nan/article/details/17849499</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m967nnv8.html">Redmine开发帮助</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok1zel9.html">在Visual Studio 2013上安装SQLite designer components</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ym72nq.html">c&plus;&plus; List、Vector、Stack、Queue使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnl3dpq.html">编程异常&mdash;&mdash;假设你报createSQLQuery is not valid without active transaction&comma;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdyp4z8.html">CentOS安装最新的Mysql版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrzkxq.html">Android 开源库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkn6zj8.html">objective-c 中数据类型之中的一个 几何数据类型（CGPoint&comma;CGSize&comma;CGRect）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojdxr5q.html">转：Web测试需要了解的知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zkln59.html">ASP&period;NET MVC5（四）：数据注解和验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojrrz1q.html">Linux服务器集群系统（LVS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k35r59.html">Python 进程（一）理论部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk0nx08.html">详述 hosts 文件的作用及修改 hosts 文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwwn5j9.html">爬虫应对js混淆的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14y0eq.html">Linux atop 监控系统状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvoy1r8.html">记一次Java调优案例分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6ry3q.html">python五十五课&mdash;&mdash;calendar模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv2e2k8.html">PHP学习-类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m21plpq.html">springmvc学习（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv4wojq.html">SSH进行登录远程主机，实验室网站，项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvnmpjq.html">【Android N 7&period;1&period;1】 处于锁屏界面时可以转屏</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rpyyd8.html">git 本地仓库和远程仓库及本地分支和远程分支</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93rdn09.html">判断一个类到底是从哪个jar包中调用的工具类</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqld53e9.html">hdu 4069 福州赛区网络赛I DLC &ast;&ast;&ast;</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g6rmzq.html">T-SQL 使用WITH高效分页</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j6xrgq.html">最值得学习的10个C语言开源项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn6lr39.html">TweenMax&lowbar;API介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k642rq.html">hdu5119 dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zpxwv9.html">DSP using MATLAB 示例Example2&period;4</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwpey38.html">去除手机端触摸滑动事件ontouchmove</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxjjxd9.html">Java学习&mdash;&mdash;开端</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
